import { Events, Interaction } from "discord.js";

export default {
	name: Events.InteractionCreate,
	async execute(interaction: Interaction) {
		if (interaction.isChatInputCommand()) {
			const command = interaction.client.commands.get(interaction.commandName);

			if (!command) {
				return console.error(`No command matching ${interaction.commandName} was found.`);
			}

			try {
				await command.execute(interaction);
			}
			catch (error) {
				console.error(error);
			}
		}
	},
};